org 400h
   numero dl 20
   risultato equ 1200h

code	; Programma principale (main)
    movl numero, R1
    jsr FATT
    jnc corretto
    movl #-1, risultato
    halt
  corretto:
    movl R0, risultato
    halt


; Subroutine per la moltiplicazione 
; Parametri in R1 e R2
; Valore di ritorno in R0
; Se avviene overflow, ritorna con C=1
MULTIPLY:
    xorl R0, R0
  loop:
    cmpl #0, R1
    jz donemult
    addl R2, R0
    jc donemult
    subl #1, R1
    jmp loop
  donemult: 
    ret

; Subroutine per il fattoriale
; Parametro in R1
; Valore di ritorno in R0
; Se avviene overflow, ritorna con C=1
FATT:
    xorl R0, R0
    push R1
	
    cmpl #1, R1	; Se R0 = 1, esegui il passo base
    jnz passoricorsivo
	
    movl R1, R2
    jmp passobase

  passoricorsivo:	
    subl #1, R1
    jsr FATT ; Salta alla stessa subroutine
    jnc nooverflow
    pop R1 ; Se c'e' stato overflow, tolgo dallo stack i valori salvati
    jmp doneFATT

  nooverflow:
    movl R0, R2

  passobase:
    pop R1
    jsr MULTIPLY

  doneFATT:
    ret

end