org 600h

    v1 dl 0,1,2,3,4,5,6,7,8,9
    v2 dl 9,8,7,6,5,4,3,2,1,0
    v3 dl 0,0,0,0,0,0,0,0,0,0
    dim equ 10

code
    xorl R0, R0	; Resetta il registro R0
    movl #dim, R1
    lsll #2, R1	; R1 ora contiene lo spiazzamento dell'ultimo elemento

 ciclo:
    cmpl R0, R1
    jz fine		; Siamo alla fine del vettore
    movl v2(R0), R2
    cmpl v1(R0), R2	; Confronta gli elementi correnti di v1 e v2
    jn Ntrue	; v2[i] - v1[i] < 0
    jnv V2magg	; v2[i] - v1[i] > 0 e no overflow
    jmp V1magg	; overflow

  Ntrue:
    jv V2magg	; overflow

  V1magg:
    movl v1(R0), v3(R0)
    jmp Inc

  V2magg:
    movl v2(R0), v3(R0)

  Inc:
    addl #4, R0	; Scorre all'elemento successivo del vettore (4 byte)
    jmp ciclo

  Fine:
    halt
end